diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/httpinfo/src/olsrd_httpinfo.c olsrd-current/lib/httpinfo/src/olsrd_httpinfo.c
--- olsrd-0.5.0/lib/httpinfo/src/olsrd_httpinfo.c	2007-02-04 23:37:36.000000000 +0100
+++ olsrd-current/lib/httpinfo/src/olsrd_httpinfo.c	2007-05-17 13:25:27.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_httpinfo.c,v 1.61 2007/02/04 22:37:36 bernd67 Exp $
+ * $Id: olsrd_httpinfo.c,v 1.67 2007/05/17 11:25:27 bernd67 Exp $
  */
 
 /*
@@ -49,6 +49,9 @@
 #include <stdarg.h>
 #include <unistd.h>
 #include <errno.h>
+#ifndef WIN32
+#include <netdb.h>
+#endif
 
 #include "olsr.h"
 #include "olsr_cfg.h"
@@ -86,11 +89,11 @@
 
 #define MAX_CLIENTS 3
 
-#define MAX_HTTPREQ_SIZE 1024 * 10
+#define MAX_HTTPREQ_SIZE (1024 * 10)
 
 #define DEFAULT_TCP_PORT 1978
 
-#define HTML_BUFSIZE 1024*75
+#define HTML_BUFSIZE (1024 * 200)
 
 #define FRAMEWIDTH 800
 
@@ -131,10 +134,10 @@
 static int
 get_http_socket(int);
 
-int
-build_tabs(char *, int);
+static int
+build_tabs(char *, olsr_u32_t, int);
 
-void
+static void
 parse_http_request(int);
 
 int
@@ -180,8 +183,13 @@
 olsr_bool
 check_allowed_ip(union olsr_ip_addr *);
 
-static char *
-get_copyright_string(void);
+
+static int
+build_ip_txt(char *buf, const olsr_u32_t bufsize, const olsr_bool want_link, const char * const ipstr, const char  * const maskstr);
+static int
+build_ipaddr_link(char *buf, const olsr_u32_t bufsize, const olsr_bool want_link, union olsr_ip_addr * const ipaddr, const union hna_netmask * const mask);
+
+static ssize_t writen(int fd, const void *buf, size_t count);
 
 static struct timeval start_time;
 static struct http_stats stats;
@@ -189,14 +197,15 @@
 static int curr_clients;
 static int http_socket;
 
-int netsprintf(char *str, const char* format, ...);
+#if 0
+int netsprintf(char *str, const char* format, ...) __attribute__((format(printf, 2, 3)));
 static int netsprintf_direct = 0;
 static int netsprintf_error = 0;
 #define sprintf netsprintf
 #define NETDIRECT
+#endif
 
-
-struct tab_entry tab_entries[] =
+static const struct tab_entry tab_entries[] =
   {
     {"Configuration", "config", build_config_body, OLSR_TRUE},
     {"Routes", "routes", build_routes_body, OLSR_TRUE},
@@ -207,10 +216,10 @@
 #endif
     {"About", "about", build_about_body, OLSR_TRUE},
     {"FOO", "cfgfile", build_cfgfile_body, OLSR_FALSE},
-    {NULL, NULL, NULL}
+    {NULL, NULL, NULL, OLSR_FALSE}
   };
 
-struct static_bin_file_entry static_bin_files[] =
+static const struct static_bin_file_entry static_bin_files[] =
   {
     {"favicon.ico", favicon_ico, 1406/*favicon_ico_len*/},
     {"logo.gif", logo_gif, 2801/*logo_gif_len*/},
@@ -218,14 +227,14 @@
     {NULL, NULL, 0}
   };
 
-struct static_txt_file_entry static_txt_files[] =
+static const struct static_txt_file_entry static_txt_files[] =
   {
     {"httpinfo.css", httpinfo_css},
     {NULL, NULL}
   };
 
 
-struct dynamic_file_entry dynamic_files[] =
+static const struct dynamic_file_entry dynamic_files[] =
   {
 #ifdef ADMIN_INTERFACE
     {"set_values", process_set_values},
@@ -240,9 +249,9 @@
  *function in uolsrd_plugin.c
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
-  get_copyright_string();
+  (void)copyright_string;
   /* Get start time */
   gettimeofday(&start_time, NULL);
 
@@ -403,7 +412,7 @@
 	      printf("Dynamic read %d bytes\n", param_size);
 	      
 	      //memcpy(body, dynamic_files[i].data, static_bin_files[i].data_size);
-	      size += dynamic_files[i].process_data_cb(req, param_size, &body[size], HTML_BUFSIZE - size);
+	      size += dynamic_files[i].process_data_cb(req, param_size, &body[size], sizeof(body)-size);
 	      c = build_http_header(HTTP_OK, OLSR_TRUE, size, req, MAX_HTTPREQ_SIZE);  
 	      goto send_http_data;
 	    }
@@ -491,12 +500,12 @@
 	      y++;
 	    }
 	  
-	  size += build_tabs(&body[size], i);
+	  size += build_tabs(&body[size], sizeof(body)-size, i);
 	  size += build_frame("Current Routes", 
 			      "routes", 
 			      FRAMEWIDTH, 
 			      &body[size], 
-			      HTML_BUFSIZE - size, 
+			      sizeof(body)-size, 
 			      tab_entries[i].build_body_cb);
 	  
 	  stats.ok_hits++;
@@ -533,14 +542,14 @@
 
  send_http_data:
   
-  r = send(client_sockets[curr_clients], req, c, 0);   
+  r = writen(client_sockets[curr_clients], req, c);   
   if(r < 0)
     {
       olsr_printf(1, "(HTTPINFO) Failed sending data to client!\n");
       goto close_connection;
     }
 
-  r = send(client_sockets[curr_clients], body, size, 0);
+  r = writen(client_sockets[curr_clients], body, size);
   if(r < 0)
     {
       olsr_printf(1, "(HTTPINFO) Failed sending data to client!\n");
@@ -557,85 +566,72 @@
 int
 build_http_header(http_header_type type, 
 		  olsr_bool is_html, 
-		  olsr_u32_t size, 
+		  olsr_u32_t msgsize, 
 		  char *buf, 
 		  olsr_u32_t bufsize)
 {
   time_t currtime;
-  char timestr[45];
-  char tmp[30];
-
-  memset(buf, 0, bufsize);
+  const char *h;
+  int size;
 
-  switch(type)
-    {
-    case(HTTP_BAD_REQ):
-      memcpy(buf, HTTP_400, strlen(HTTP_400));
+  switch(type) {
+  case(HTTP_BAD_REQ):
+      h = HTTP_400;
       break;
-    case(HTTP_BAD_FILE):
-      memcpy(buf, HTTP_404, strlen(HTTP_404));
+  case(HTTP_BAD_FILE):
+      h = HTTP_404;
       break;
-    default:
+  default:
       /* Defaults to OK */
-      memcpy(buf, HTTP_200, strlen(HTTP_200));
+      h = HTTP_200;
       break;
-    }
-
+  }
+  size = snprintf(buf, bufsize, "%s", h);
 
   /* Date */
-  if(time(&currtime))
-    {
-      strftime(timestr, 45, "Date: %a, %d %b %Y %H:%M:%S GMT\r\n", localtime(&currtime));
-      strcat(buf, timestr);
-    }
+  time(&currtime);
+  size += strftime(&buf[size], bufsize-size, "Date: %a, %d %b %Y %H:%M:%S GMT\r\n", localtime(&currtime));
   
   /* Server version */
-  strcat(buf, "Server: " PLUGIN_NAME " " PLUGIN_VERSION " " HTTP_VERSION "\r\n");
+  size += snprintf(&buf[size], bufsize-size, "Server: %s %s %s\r\n", PLUGIN_NAME, PLUGIN_VERSION, HTTP_VERSION);
 
   /* connection-type */
-  strcat(buf,"Connection: closed\r\n");
+  size += snprintf(&buf[size], bufsize-size, "Connection: closed\r\n");
 
   /* MIME type */
-  if(is_html)
-    strcat(buf, "Content-type: text/html\r\n");
-  else
-    strcat(buf, "Content-type: text/plain\r\n");
+  size += snprintf(&buf[size], bufsize-size, "Content-type: text/%s\r\n", is_html ? "html" : "plain");
 
   /* Content length */
-  if(size > 0)
-    {
-      snprintf(tmp, sizeof(tmp), "Content-length: %i\r\n", size);
-      strcat(buf, tmp);
-    }
-
+  if(msgsize > 0) {
+      size += snprintf(&buf[size], bufsize-size, "Content-length: %i\r\n", msgsize);
+  }
 
   /* Cache-control 
    * No caching dynamic pages
    */
-  strcat(buf, "Cache-Control: no-cache\r\n");
-
-  if(!is_html)
-    strcat(buf, "Accept-Ranges: bytes\r\n");
+  size += snprintf(&buf[size], bufsize-size, "Cache-Control: no-cache\r\n");
 
+  if(!is_html) {
+    size += snprintf(&buf[size], bufsize-size, "Accept-Ranges: bytes\r\n");
+  }
   /* End header */
-  strcat(buf, "\r\n");
+  size += snprintf(&buf[size], bufsize-size, "\r\n");
   
   olsr_printf(1, "HEADER:\n%s", buf);
 
-  return strlen(buf);
-
+  return size;
 }
 
 
 
 int 
-build_tabs(char *buf, int active)
+build_tabs(char *buf, const olsr_u32_t bufsize, int active)
 {
   int size = 0, i = 0, tabs = 0;
 
   while(strcmp(html_tabs[i], "<!-- TAB ELEMENTS -->"))
     {
-      size += sprintf(&buf[size], html_tabs[i]);
+      size += snprintf(&buf[size], bufsize-size, html_tabs[i]);
       i++;
     }
 
@@ -647,13 +643,13 @@
 	continue;
 
       if(tabs == active)
-	size += sprintf(&buf[size], 
+	size += snprintf(&buf[size], bufsize-size, 
 			html_tabs[i], 
 			tab_entries[tabs].filename, 
 			ACTIVE_TAB, 
 			tab_entries[tabs].tab_label);
       else
-	size += sprintf(&buf[size], 
+	size += snprintf(&buf[size], bufsize-size, 
 			html_tabs[i], 
 			tab_entries[tabs].filename, 
 			" ", 
@@ -663,7 +659,7 @@
   i++;      
   while(html_tabs[i])
     {
-      size += sprintf(&buf[size], html_tabs[i]);
+      size += snprintf(&buf[size], bufsize-size, html_tabs[i]);
       i++;
     }
   
@@ -675,7 +671,7 @@
  * destructor - called at unload
  */
 void
-olsr_plugin_exit()
+olsr_plugin_exit(void)
 {
   if(http_socket)
     close(http_socket);
@@ -683,9 +679,9 @@
 
 
 static int
-build_frame(char *title, 
-	    char *link, 
-	    int width,
+build_frame(char *title __attribute__((unused)), 
+	    char *link __attribute__((unused)), 
+	    int width __attribute__((unused)),
 	    char *buf,
 	    olsr_u32_t bufsize, 
 	    int(*frame_body_cb)(char *, olsr_u32_t))
@@ -695,9 +691,9 @@
   while(http_frame[i])
     {
       if(!strcmp(http_frame[i], "<!-- BODY -->"))
-	size += frame_body_cb(&buf[size], bufsize - size);
+	size += frame_body_cb(&buf[size], bufsize-size);
       else
-	size += sprintf(&buf[size], http_frame[i]);      
+	size += snprintf(&buf[size], bufsize-size, "%s", http_frame[i]);      
 
       i++;
     }
@@ -705,7 +701,67 @@
   return size;
 }
 
+static int
+build_ip_txt(char *buf, const olsr_u32_t bufsize, const olsr_bool want_link, const char * const ipstr, const char  * const maskstr)
+{
+  int size = 0;
+  if (want_link && maskstr == NULL) { /* Print the link only if there is not netmask */
+    size += snprintf(&buf[size],
+                     bufsize-size,
+                     "<a href=\"http://%s:%d/all\">",
+                     ipstr,
+                     http_port);
+  }
+  size += snprintf(&buf[size], bufsize-size, "%s", ipstr);
+  if (maskstr) {
+    size += snprintf(&buf[size], bufsize-size, "/%s", maskstr);
+  }
+  if (want_link && maskstr == NULL) { /* Print the link only if there is not netmask */
+    size += snprintf(&buf[size], bufsize-size, "</a>");
+  }
+  return size;
+}
 
+static int
+build_ipaddr_link(char *buf, const olsr_u32_t bufsize, const olsr_bool want_link, union olsr_ip_addr * const ipaddr, const union hna_netmask * const mask)
+{
+  int size = 0;
+  char maskbuf[32];
+  char *maskstr;
+  const struct hostent * const hp =
+#ifndef WIN32
+                                    resolve_ip_addresses ? gethostbyaddr(ipaddr, olsr_cnf->ipsize, olsr_cnf->ip_version) :
+#endif
+                                        NULL;
+  if (mask != NULL) {
+    if (olsr_cnf->ip_version == AF_INET) {
+      if (mask->v4 == ~0U) {
+        maskstr = NULL;
+      } else {
+        struct in_addr in;
+        in.s_addr = mask->v4;
+        snprintf(maskbuf, sizeof(maskbuf), "%s", inet_ntoa(in));
+        maskstr = maskbuf;
+      }
+    } else {
+      snprintf(maskbuf, sizeof(maskbuf), "%d", mask->v6);
+      maskstr = maskbuf;
+    }
+  } else {
+    maskstr =  NULL;
+  }
+  size += snprintf(&buf[size], bufsize-size, "<td%s>", resolve_ip_addresses && hp ? "" : " colspan=\"2\"");
+  size += build_ip_txt(&buf[size], bufsize-size, want_link, olsr_ip_to_string(ipaddr), maskstr);
+  if (hp) {
+    size += snprintf(&buf[size], bufsize-size, "</td><td>(");
+    size += build_ip_txt(&buf[size], bufsize-size, want_link, hp->h_name, NULL);
+    size += snprintf(&buf[size], bufsize-size, ")");
+  }
+  size += snprintf(&buf[size], bufsize-size, "</td>");
+  return size;
+}
+#define build_ipaddr_with_link(buf, bufsize, ipaddr, mask) build_ipaddr_link((buf), (bufsize), OLSR_TRUE, (ipaddr), (mask))
+#define build_ipaddr_no_link(buf, bufsize, ipaddr, mask)   build_ipaddr_link((buf), (bufsize), OLSR_FALSE, (ipaddr), (mask))
 
 int
 build_routes_body(char *buf, olsr_u32_t bufsize)
@@ -713,12 +769,13 @@
   int size = 0, index;
   struct rt_entry *routes;
 
-  size += sprintf(&buf[size], "<h2>OLSR routes in kernel</h2>\n");
+  size += snprintf(&buf[size], bufsize-size, "<h2>OLSR routes in kernel</h2>\n");
 
-  size += sprintf(&buf[size], "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Destination</th><th>Gateway</th><th>Metric</th>");
+  size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\"><tr><th%s>Destination</th><th>Gateway</th><th>Metric</th>",
+                  resolve_ip_addresses ? " colspan=\"2\"" : "");
   if (olsr_cnf->lq_level > 0)
-    size += sprintf(&buf[size], "<th>ETX</th>");
-  size += sprintf(&buf[size], "<th>Interface</th><th>Type</th></tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "<th>ETX</th>");
+  size += snprintf(&buf[size], bufsize-size, "<th>Interface</th><th>Type</th></tr>\n");
 
   /* Neighbors */
   for(index = 0;index < HASHSIZE;index++)
@@ -727,20 +784,14 @@
 	  routes != &routingtable[index];
 	  routes = routes->next)
 	{
-	  size += sprintf(&buf[size],
-                         "<tr><td><a href=\"http://%s:%d/all\">%s</a></td>"
-                         "<td><a href=\"http://%s:%d/all\">%s</a></td>"
-                         "<td>%d</td>",
-                         olsr_ip_to_string(&routes->rt_dst),
-                         http_port,
-                         olsr_ip_to_string(&routes->rt_dst),
-                         olsr_ip_to_string(&routes->rt_router),
-                         http_port,
-                         olsr_ip_to_string(&routes->rt_router),
-                         routes->rt_metric);
+          size += snprintf(&buf[size], bufsize-size, "<tr>");
+	  size += build_ipaddr_with_link(&buf[size], bufsize-size, &routes->rt_dst, NULL);
+	  size += build_ipaddr_with_link(&buf[size], bufsize-size, &routes->rt_router, NULL);
+
+	  size += snprintf(&buf[size], bufsize-size, "<td align=\"right\">%d</td>", routes->rt_metric);
           if (olsr_cnf->lq_level > 0)
-	    size += sprintf(&buf[size], "<td>%.2f</td>", routes->rt_etx);
-	  size += sprintf(&buf[size],
+            size += snprintf(&buf[size], bufsize-size, "<td align=\"right\">%.2f</td>", routes->rt_etx);
+	  size += snprintf(&buf[size], bufsize-size,
                          "<td>%s</td>"
                          "<td>HOST</td></tr>\n",
                          routes->rt_if->int_name);
@@ -754,25 +805,22 @@
 	  routes != &hna_routes[index];
 	  routes = routes->next)
 	{
-	  size += sprintf(&buf[size],
-                         "<tr><td>%s</td>"
-                         "<td><a href=\"http://%s:%d/all\">%s</a></td>"
-                         "<td>%d</td>",
-                         olsr_ip_to_string(&routes->rt_dst),
-                         olsr_ip_to_string(&routes->rt_router),
-                         http_port,
-                         olsr_ip_to_string(&routes->rt_router),
+          size += snprintf(&buf[size], bufsize-size, "<tr>");
+	  size += build_ipaddr_with_link(&buf[size], bufsize-size, &routes->rt_dst, &routes->rt_mask);
+	  size += build_ipaddr_with_link(&buf[size], bufsize-size, &routes->rt_router, NULL);
+	  size += snprintf(&buf[size], bufsize-size,
+                         "<td align=\"right\">%d</td>",
                          routes->rt_metric);
           if (olsr_cnf->lq_level > 0)
-	    size += sprintf(&buf[size], "<td>%.2f</td>", routes->rt_etx);
-	  size += sprintf(&buf[size],
+	    size += snprintf(&buf[size], bufsize-size, "<td align=\"right\">%.2f</td>", routes->rt_etx);
+	  size += snprintf(&buf[size], bufsize-size,
                          "<td>%s</td>"
                          "<td>HNA</td></tr>\n",
                          routes->rt_if->int_name);
 	}
     }
 
-  size += sprintf(&buf[size], "</table>\n");
+  size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
   return size;
 }
@@ -802,169 +850,169 @@
     strftime(systime, 100, "System time: <i>%a, %d %b %Y %H:%M:%S</i><br>", localtime(&currtime));
 
 
-    size += sprintf(&buf[size], "OS: %s\n<br>", OS);
+    size += snprintf(&buf[size], bufsize-size, "OS: %s\n<br>", OS);
 
-    size += sprintf(&buf[size], "%s\n", systime);
+    size += snprintf(&buf[size], bufsize-size, "%s\n", systime);
 
     if(days)
-      size += sprintf(&buf[size], "Olsrd uptime: <i>%d day(s) %02d hours %02d minutes %02d seconds</i><br>\n", days, hours, mins, (int)uptime.tv_sec);
+      size += snprintf(&buf[size], bufsize-size, "Olsrd uptime: <i>%d day(s) %02d hours %02d minutes %02d seconds</i><br>\n", days, hours, mins, (int)uptime.tv_sec);
     else
-      size += sprintf(&buf[size], "Olsrd uptime: <i>%02d hours %02d minutes %02d seconds</i><br>\n", hours, mins, (int)uptime.tv_sec);
+      size += snprintf(&buf[size], bufsize-size, "Olsrd uptime: <i>%02d hours %02d minutes %02d seconds</i><br>\n", hours, mins, (int)uptime.tv_sec);
 
-    size += sprintf(&buf[size], "HTTP stats(ok/dyn/error/illegal): <i>%d/%d/%d/%d</i><br>\n", stats.ok_hits, stats.dyn_hits, stats.err_hits, stats.ill_hits);
+    size += snprintf(&buf[size], bufsize-size, "HTTP stats(ok/dyn/error/illegal): <i>%d/%d/%d/%d</i><br>\n", stats.ok_hits, stats.dyn_hits, stats.err_hits, stats.ill_hits);
 
-    size += sprintf(&buf[size], "Click <a href=\"/cfgfile\">here</a> to <i>generate a configuration file for this node</i>.\n");
+    size += snprintf(&buf[size], bufsize-size, "Click <a href=\"/cfgfile\">here</a> to <i>generate a configuration file for this node</i>.\n");
 
-    size += sprintf(&buf[size], "<h2>Variables</h2>\n");
+    size += snprintf(&buf[size], bufsize-size, "<h2>Variables</h2>\n");
 
-    size += sprintf(&buf[size], "<table width=\"100%%\" border=0>\n<tr>");
+    size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" border=0>\n<tr>");
 
-    size += sprintf(&buf[size], "<td>Main address: <b>%s</b></td>\n", olsr_ip_to_string(&olsr_cnf->main_addr));
+    size += snprintf(&buf[size], bufsize-size, "<td>Main address: <b>%s</b></td>\n", olsr_ip_to_string(&olsr_cnf->main_addr));
     
-    size += sprintf(&buf[size], "<td>IP version: %d</td>\n", olsr_cnf->ip_version == AF_INET ? 4 : 6);
+    size += snprintf(&buf[size], bufsize-size, "<td>IP version: %d</td>\n", olsr_cnf->ip_version == AF_INET ? 4 : 6);
 
-    size += sprintf(&buf[size], "<td>Debug level: %d</td>\n", olsr_cnf->debug_level);
+    size += snprintf(&buf[size], bufsize-size, "<td>Debug level: %d</td>\n", olsr_cnf->debug_level);
 
-    size += sprintf(&buf[size], "</tr>\n<tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "</tr>\n<tr>\n");
 
-    size += sprintf(&buf[size], "<td>Pollrate: %0.2f</td>\n", olsr_cnf->pollrate);
-    size += sprintf(&buf[size], "<td>TC redundancy: %d</td>\n", olsr_cnf->tc_redundancy);
-    size += sprintf(&buf[size], "<td>MPR coverage: %d</td>\n", olsr_cnf->mpr_coverage);
+    size += snprintf(&buf[size], bufsize-size, "<td>Pollrate: %0.2f</td>\n", olsr_cnf->pollrate);
+    size += snprintf(&buf[size], bufsize-size, "<td>TC redundancy: %d</td>\n", olsr_cnf->tc_redundancy);
+    size += snprintf(&buf[size], bufsize-size, "<td>MPR coverage: %d</td>\n", olsr_cnf->mpr_coverage);
 
 
-    size += sprintf(&buf[size], "</tr>\n<tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "</tr>\n<tr>\n");
 
-    size += sprintf(&buf[size], "<td>Fisheye: %s</td>\n", olsr_cnf->lq_fish ? "Enabled" : "Disabled");
+    size += snprintf(&buf[size], bufsize-size, "<td>Fisheye: %s</td>\n", olsr_cnf->lq_fish ? "Enabled" : "Disabled");
 
-    size += sprintf(&buf[size], "<td>TOS: 0x%04x</td>\n", olsr_cnf->tos);
+    size += snprintf(&buf[size], bufsize-size, "<td>TOS: 0x%04x</td>\n", olsr_cnf->tos);
 
-    size += sprintf(&buf[size], "<td>Willingness: %d %s</td>\n", olsr_cnf->willingness, olsr_cnf->willingness_auto ? "(auto)" : "");
+    size += snprintf(&buf[size], bufsize-size, "<td>Willingness: %d %s</td>\n", olsr_cnf->willingness, olsr_cnf->willingness_auto ? "(auto)" : "");
     
-    size += sprintf(&buf[size], "</tr>\n<tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "</tr>\n<tr>\n");
 
     if (olsr_cnf->lq_level == 0)
       {
-        size += sprintf(&buf[size], "<td>Hysteresis: %s</td>\n", olsr_cnf->use_hysteresis ? "Enabled" : "Disabled");
+        size += snprintf(&buf[size], bufsize-size, "<td>Hysteresis: %s</td>\n", olsr_cnf->use_hysteresis ? "Enabled" : "Disabled");
 	if (olsr_cnf->use_hysteresis)
           {
-            size += sprintf(&buf[size], "<td>Hyst scaling: %0.2f</td>\n", olsr_cnf->hysteresis_param.scaling);
-            size += sprintf(&buf[size], "<td>Hyst lower/upper: %0.2f/%0.2f</td>\n", olsr_cnf->hysteresis_param.thr_low, olsr_cnf->hysteresis_param.thr_high);
+            size += snprintf(&buf[size], bufsize-size, "<td>Hyst scaling: %0.2f</td>\n", olsr_cnf->hysteresis_param.scaling);
+            size += snprintf(&buf[size], bufsize-size, "<td>Hyst lower/upper: %0.2f/%0.2f</td>\n", olsr_cnf->hysteresis_param.thr_low, olsr_cnf->hysteresis_param.thr_high);
           }
       }
 
-    size += sprintf(&buf[size], "</tr>\n<tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "</tr>\n<tr>\n");
 
-    size += sprintf(&buf[size], "<td>LQ extension: %s</td>\n", olsr_cnf->lq_level ? "Enabled" : "Disabled");
+    size += snprintf(&buf[size], bufsize-size, "<td>LQ extension: %s</td>\n", olsr_cnf->lq_level ? "Enabled" : "Disabled");
     if (olsr_cnf->lq_level)
       {
-        size += sprintf(&buf[size], "<td>LQ level: %d</td>\n", olsr_cnf->lq_level);
-        size += sprintf(&buf[size], "<td>LQ winsize: %d</td>\n", olsr_cnf->lq_wsize);
+        size += snprintf(&buf[size], bufsize-size, "<td>LQ level: %d</td>\n", olsr_cnf->lq_level);
+        size += snprintf(&buf[size], bufsize-size, "<td>LQ winsize: %d</td>\n", olsr_cnf->lq_wsize);
       }
 
-    size += sprintf(&buf[size], "</tr></table>\n");
+    size += snprintf(&buf[size], bufsize-size, "</tr></table>\n");
 
-    size += sprintf(&buf[size], "<h2>Interfaces</h2>\n");
+    size += snprintf(&buf[size], bufsize-size, "<h2>Interfaces</h2>\n");
 
 
-    size += sprintf(&buf[size], "<table width=\"100%%\" border=0>\n");
+    size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" border=0>\n");
 
 
     for(ifs = olsr_cnf->interfaces; ifs; ifs = ifs->next)
       {
 	struct interface *rifs = ifs->interf;
 
-	size += sprintf(&buf[size], "<tr><th colspan=3>%s</th>\n", ifs->name);
+	size += snprintf(&buf[size], bufsize-size, "<tr><th colspan=3>%s</th>\n", ifs->name);
 	if(!rifs)
 	  {
-	    size += sprintf(&buf[size], "<tr><td colspan=3>Status: DOWN</td></tr>\n");
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td colspan=3>Status: DOWN</td></tr>\n");
 	    continue;
 	  }
 	
 	if(olsr_cnf->ip_version == AF_INET)
 	  {
-	    size += sprintf(&buf[size], "<tr><td>IP: %s</td>\n", 
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td>IP: %s</td>\n", 
 			    sockaddr_to_string(&rifs->int_addr));
-	    size += sprintf(&buf[size], "<td>MASK: %s</td>\n", 
+	    size += snprintf(&buf[size], bufsize-size, "<td>MASK: %s</td>\n", 
 			    sockaddr_to_string(&rifs->int_netmask));
-	    size += sprintf(&buf[size], "<td>BCAST: %s</td></tr>\n",
+	    size += snprintf(&buf[size], bufsize-size, "<td>BCAST: %s</td></tr>\n",
 			    sockaddr_to_string(&rifs->int_broadaddr));
-	    size += sprintf(&buf[size], "<tr><td>MTU: %d</td>\n", rifs->int_mtu);
-	    size += sprintf(&buf[size], "<td>WLAN: %s</td>\n", rifs->is_wireless ? "Yes" : "No");
-	    size += sprintf(&buf[size], "<td>STATUS: UP</td></tr>\n");
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td>MTU: %d</td>\n", rifs->int_mtu);
+	    size += snprintf(&buf[size], bufsize-size, "<td>WLAN: %s</td>\n", rifs->is_wireless ? "Yes" : "No");
+	    size += snprintf(&buf[size], bufsize-size, "<td>STATUS: UP</td></tr>\n");
 	  }
 	else
 	  {
-	    size += sprintf(&buf[size], "<tr><td>IP: %s</td>\n", olsr_ip_to_string((union olsr_ip_addr *)&rifs->int6_addr.sin6_addr));
-	    size += sprintf(&buf[size], "<td>MCAST: %s</td>\n", olsr_ip_to_string((union olsr_ip_addr *)&rifs->int6_multaddr.sin6_addr));
-	    size += sprintf(&buf[size], "<td></td></tr>\n");
-	    size += sprintf(&buf[size], "<tr><td>MTU: %d</td>\n", rifs->int_mtu);
-	    size += sprintf(&buf[size], "<td>WLAN: %s</td>\n", rifs->is_wireless ? "Yes" : "No");
-	    size += sprintf(&buf[size], "<td>STATUS: UP</td></tr>\n");
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td>IP: %s</td>\n", olsr_ip_to_string((union olsr_ip_addr *)&rifs->int6_addr.sin6_addr));
+	    size += snprintf(&buf[size], bufsize-size, "<td>MCAST: %s</td>\n", olsr_ip_to_string((union olsr_ip_addr *)&rifs->int6_multaddr.sin6_addr));
+	    size += snprintf(&buf[size], bufsize-size, "<td></td></tr>\n");
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td>MTU: %d</td>\n", rifs->int_mtu);
+	    size += snprintf(&buf[size], bufsize-size, "<td>WLAN: %s</td>\n", rifs->is_wireless ? "Yes" : "No");
+	    size += snprintf(&buf[size], bufsize-size, "<td>STATUS: UP</td></tr>\n");
 	  }	    
       }
 
-    size += sprintf(&buf[size], "</table>\n");
+    size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
     if(olsr_cnf->allow_no_interfaces)
-      size += sprintf(&buf[size], "<i>Olsrd is configured to run even if no interfaces are available</i><br>\n");
+      size += snprintf(&buf[size], bufsize-size, "<i>Olsrd is configured to run even if no interfaces are available</i><br>\n");
     else
-      size += sprintf(&buf[size], "<i>Olsrd is configured to halt if no interfaces are available</i><br>\n");
+      size += snprintf(&buf[size], bufsize-size, "<i>Olsrd is configured to halt if no interfaces are available</i><br>\n");
 
-    size += sprintf(&buf[size], "<h2>Plugins</h2>\n");
+    size += snprintf(&buf[size], bufsize-size, "<h2>Plugins</h2>\n");
 
-    size += sprintf(&buf[size], "<table width=\"100%%\" border=0><tr><th>Name</th><th>Parameters</th></tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" border=0><tr><th>Name</th><th>Parameters</th></tr>\n");
 
     for(pentry = olsr_cnf->plugins; pentry; pentry = pentry->next)
       {
-	size += sprintf(&buf[size], "<tr><td>%s</td>\n", pentry->name);
+	size += snprintf(&buf[size], bufsize-size, "<tr><td>%s</td>\n", pentry->name);
 
-	size += sprintf(&buf[size], "<td><select>\n");
-	size += sprintf(&buf[size], "<option>KEY, VALUE</option>\n");
+	size += snprintf(&buf[size], bufsize-size, "<td><select>\n");
+	size += snprintf(&buf[size], bufsize-size, "<option>KEY, VALUE</option>\n");
 
 	for(pparam = pentry->params; pparam; pparam = pparam->next)
 	  {
-	    size += sprintf(&buf[size], "<option>\"%s\", \"%s\"</option>\n",
+	    size += snprintf(&buf[size], bufsize-size, "<option>\"%s\", \"%s\"</option>\n",
 			    pparam->key,
 			    pparam->value);
 	  }
-	size += sprintf(&buf[size], "</select></td></tr>\n");
+	size += snprintf(&buf[size], bufsize-size, "</select></td></tr>\n");
 
       }
 
-    size += sprintf(&buf[size], "</table>\n");
+    size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
 
     if((olsr_cnf->ip_version == AF_INET) && (olsr_cnf->hna4_entries))
       {
 	struct hna4_entry *hna4;
 	
-	size += sprintf(&buf[size], "<h2>Announced HNA entries</h2>\n");
-	size += sprintf(&buf[size], "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Network</th><th>Netmask</th></tr>\n");
+	size += snprintf(&buf[size], bufsize-size, "<h2>Announced HNA entries</h2>\n");
+	size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Network</th><th>Netmask</th></tr>\n");
 	
 	for(hna4 = olsr_cnf->hna4_entries; hna4; hna4 = hna4->next)
 	  {
-	    size += sprintf(&buf[size], "<tr><td>%s</td><td>%s</td></tr>\n", 
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td>%s</td><td>%s</td></tr>\n", 
 			    olsr_ip_to_string((union olsr_ip_addr *)&hna4->net),
 			    olsr_ip_to_string((union olsr_ip_addr *)&hna4->netmask));
 	  }
 	
-	size += sprintf(&buf[size], "</table>\n");
-      }
-    else if((olsr_cnf->ip_version == AF_INET6) && (olsr_cnf->hna6_entries))
+	size += snprintf(&buf[size], bufsize-size, "</table>\n");
+      } 
+   else if((olsr_cnf->ip_version == AF_INET6) && (olsr_cnf->hna6_entries))
       {
 	struct hna6_entry *hna6;
 	
-	size += sprintf(&buf[size], "<h2>Announced HNA entries</h2>\n");
-	size += sprintf(&buf[size], "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Network</th><th>Prefix length</th></tr>\n");
+	size += snprintf(&buf[size], bufsize-size, "<h2>Announced HNA entries</h2>\n");
+	size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Network</th><th>Prefix length</th></tr>\n");
 	
 	for(hna6 = olsr_cnf->hna6_entries; hna6; hna6 = hna6->next)
 	  {
-	    size += sprintf(&buf[size], "<tr><td>%s</td><td>%d</td></tr>\n", 
+	    size += snprintf(&buf[size], bufsize-size, "<tr><td>%s</td><td>%d</td></tr>\n", 
 			    olsr_ip_to_string((union olsr_ip_addr *)&hna6->net),
 			    hna6->prefix_len);
 	  }
 	
-	size += sprintf(&buf[size], "</table>\n");
+	size += snprintf(&buf[size], bufsize-size, "</table>\n");
       }
     
 
